<script setup lang="ts">
import {
  WorkflowVersionStatus,
  WorkflowExecutionStatus,
} from "@/client/types.gen";
import type {
  AnonymizedWorkflowExecution,
  WorkflowOut,
  WorkflowVersionOut,
} from "@/client/types.gen";
import { computed, onMounted, ref } from "vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import dayjs from "dayjs";
import { sortedVersions } from "@/utils/Workflow";
import { Tooltip } from "bootstrap";
import { useWorkflowExecutionStore } from "@/stores/workflowExecutions";
import { useOTRStore } from "@/stores/otrs";

const workflowExecutionRepository = useWorkflowExecutionStore();
const otrRepository = useOTRStore();

const props = defineProps<{
  workflow: WorkflowOut;
  loading: boolean;
}>();
const truncateDescription = ref<boolean>(true);
const randomIDSuffix: string = Math.random().toString(16).substring(2, 8);

const emit = defineEmits<{
  (e: "workflow-update-click", workflow: WorkflowOut): void;
  (e: "workflow-delete-click", workflow: WorkflowOut): void;
  (e: "workflow-update-credentials-click", workflow: WorkflowOut): void;
  (e: "workflow-update-icon-click", version: WorkflowVersionOut): void;
  (e: "show-otr-click", workflowId: string): void;
  (e: "create-otr-click", workflow: WorkflowOut): void;
}>();

const workflowExecutions = computed<AnonymizedWorkflowExecution[]>(() =>
  workflowExecutionRepository.anonymizedExecutions.filter(
    (execution) => execution.workflow_id == props.workflow.workflow_id,
  ),
);

const executionsByVersion = computed<
  Record<string, AnonymizedWorkflowExecution[]>
>(() => {
  const mapping: Record<string, AnonymizedWorkflowExecution[]> = {};
  for (const version of props.workflow.versions) {
    mapping[version.workflow_version_id] = [];
  }
  for (const execution of workflowExecutions.value) {
    mapping[execution.workflow_version_id].push(execution);
  }
  return mapping;
});

const statusToIconMapping: Record<string, string> = {
  PUBLISHED: "fa-solid fa-circle-check",
  DENIED: "fa-solid fa-x",
  CREATED: "fa-solid fa-circle-pause",
  DEPRECATED: "fa-solid fa-box-archive",
};

function successfulExecutions(
  executions: AnonymizedWorkflowExecution[],
): number {
  return executions.filter(
    (execution) => execution.status === WorkflowExecutionStatus.SUCCESS,
  ).length;
}

function unsuccessfulExecutions(
  executions: AnonymizedWorkflowExecution[],
): number {
  return executions.filter(
    (execution) => execution.status !== WorkflowExecutionStatus.SUCCESS,
  ).length;
}

function uniqueUsers(executions: AnonymizedWorkflowExecution[]): number {
  return executions.filter(
    // filter unique UIDs
    (execution, index, array) =>
      array.findIndex((val) => val.pseudo_uid === execution.pseudo_uid) ===
      index,
  ).length;
}

onMounted(() => {
  if (!props.loading) {
    document
      .querySelector("#workflow-card-" + randomIDSuffix)
      ?.querySelectorAll('[data-bs-toggle="tooltip"]')
      .forEach((tooltipTriggerEl) =>
        Tooltip.getOrCreateInstance(tooltipTriggerEl),
      );
  }
});
</script>

<template>
  <div
    :id="'workflow-card-' + randomIDSuffix"
    class="card-hover border border-secondary card m-2"
  >
    <div class="card-body">
      <div
        class="card-title fs-3 d-flex justify-content-between align-items-center"
      >
        <div v-if="props.loading" class="placeholder-glow w-100">
          <span class="placeholder col-6"></span>
        </div>
        <div v-else class="text-truncate d-inline-flex align-items-center">
          <span>{{ props.workflow.name }}</span>
          <font-awesome-icon
            v-if="props.workflow.private"
            icon="fa-solid fa-lock"
            class="fs-5 ms-2 tooltip-private-repository"
            tooltip="Private Git repository"
          />
          <font-awesome-icon
            v-if="otrRepository.otrMapping[workflow.workflow_id]"
            icon="fa-solid fa-people-arrows"
            class="fs-5 ms-2 cursor-pointer hover-info"
            tooltip="Ownership transfer requested"
            @click="emit('show-otr-click', workflow.workflow_id)"
          />
        </div>
        <div class="btn-group">
          <button
            type="button"
            class="btn btn-outline-success"
            :class="{ disabled: props.loading }"
            data-bs-toggle="modal"
            data-bs-target="#updateWorkflowModal"
            @click="emit('workflow-update-click', workflow)"
          >
            Update
          </button>
          <button
            type="button"
            class="btn btn-outline-success dropdown-toggle dropdown-toggle-split"
            data-bs-toggle="dropdown"
            aria-expanded="false"
          >
            <span class="visually-hidden">Toggle Dropdown</span>
          </button>
          <ul class="dropdown-menu z-3">
            <li
              v-if="otrRepository.otrMapping[workflow.workflow_id] == undefined"
            >
              <button
                type="button"
                class="dropdown-item"
                @click="emit('create-otr-click', workflow)"
              >
                Transfer ownership
              </button>
            </li>
            <li>
              <a
                class="dropdown-item"
                href="#"
                :class="{ disabled: props.loading }"
                data-bs-toggle="modal"
                data-bs-target="#updateWorkflowCredentialsModal"
                @click.prevent="
                  emit('workflow-update-credentials-click', props.workflow)
                "
                >Update Credentials</a
              >
            </li>
            <li>
              <router-link
                :to="{
                  name: 'workflows-clowminfo',
                  query: {
                    workflow_id: workflow.workflow_id,
                    workflow_version_id: sortedVersions(
                      props.workflow.versions,
                    )[0]?.workflow_version_id,
                  },
                }"
                class="btn btn-primary dropdown-item"
                >Edit Parameter Metadata
              </router-link>
            </li>
            <li>
              <a
                class="dropdown-item text-danger"
                href="#"
                :class="{ disabled: props.loading }"
                data-bs-toggle="modal"
                data-bs-target="#deleteWorkflowModal"
                @click.prevent="emit('workflow-delete-click', props.workflow)"
                >Delete
                <font-awesome-icon icon="fa-solid fa-trash" class="ms-2" />
              </a>
            </li>
          </ul>
        </div>
      </div>
      <p class="card-text" :class="{ 'text-truncate': truncateDescription }">
        <span v-if="props.loading" class="placeholder-glow"
          ><span class="placeholder col-12"></span
        ></span>
        <span
          v-else
          :class="{
            'cursor-pointer': truncateDescription,
          }"
          @click="truncateDescription = false"
          >{{ props.workflow.short_description }}</span
        >
      </p>
      <div>
        <div v-if="props.loading" class="row placeholder-glow p-3">
          <span class="placeholder col-md-1"></span>
          <span class="placeholder col-md-2 offset-md-1 bg-success"></span>
          <span class="placeholder col-md-2 offset-md-3"></span>
          <span class="placeholder col-md-1 offset-md-1 bg-primary"></span>
        </div>
        <div v-else>
          <table class="table table-sm table-hover">
            <thead>
              <tr>
                <th scope="col">Version</th>
                <th scope="col">Status</th>
                <th scope="col">Updated at</th>
                <th scope="col">Nextflow version</th>
                <th scope="col" class="text-align-center">Usage</th>
                <th scope="col" class="text-align-center">Icon</th>
                <th scope="col"></th>
              </tr>
            </thead>
            <tbody class="table-group-divider">
              <tr
                v-for="version in sortedVersions(props.workflow.versions)"
                :key="version.workflow_version_id"
              >
                <th scope="row" class="fw-bold">{{ version.version }}</th>
                <td
                  :class="{
                    'text-success':
                      version.status === WorkflowVersionStatus.PUBLISHED,
                    'text-danger':
                      version.status === WorkflowVersionStatus.DENIED,
                    'text-secondary':
                      version.status === WorkflowVersionStatus.CREATED,
                    'text-warning':
                      version.status === WorkflowVersionStatus.DEPRECATED,
                  }"
                >
                  <font-awesome-icon
                    :icon="statusToIconMapping[version.status]"
                  />
                  {{ version.status }}
                </td>
                <td>
                  {{ dayjs.unix(version.created_at).format("DD MMM YYYY") }}
                </td>
                <td class="text-align-center">
                  {{ version.nextflow_version }}
                </td>
                <td class="text-align-center">
                  <span
                    class="text-success me-1"
                    data-bs-toggle="tooltip"
                    data-bs-title="Successful Workflow Executions"
                  >
                    {{
                      successfulExecutions(
                        executionsByVersion[version.workflow_version_id],
                      )
                    }}
                    <font-awesome-icon icon="fa-solid fa-circle-check" />
                  </span>
                  <span
                    class="text-danger me-1"
                    data-bs-toggle="tooltip"
                    data-bs-title="Unsuccessful Workflow Executions"
                  >
                    {{
                      unsuccessfulExecutions(
                        executionsByVersion[version.workflow_version_id],
                      )
                    }}
                    <font-awesome-icon icon="fa-solid fa-x" />
                  </span>
                  <span data-bs-toggle="tooltip" data-bs-title="Unique Users">
                    {{
                      uniqueUsers(
                        executionsByVersion[version.workflow_version_id],
                      )
                    }}
                    <font-awesome-icon icon="fa-solid fa-user" />
                  </span>
                </td>
                <td class="text-align-center">
                  <img
                    v-if="version.icon_url != null"
                    :src="version.icon_url"
                    alt="Workflow Version Icon"
                    class="cursor-pointer"
                    data-bs-toggle="modal"
                    data-bs-target="#updateWorkflowVersionIconModal"
                    @click="emit('workflow-update-icon-click', version)"
                  />
                </td>
                <td class="text-end">
                  <font-awesome-icon
                    icon="fa-solid fa-bars"
                    data-bs-toggle="dropdown"
                    aria-expanded="false"
                    class="cursor-pointer p-1"
                  />
                  <ul class="dropdown-menu dropdown-menu-end">
                    <li>
                      <router-link
                        class="dropdown-item"
                        :to="{
                          name: 'workflow-version',
                          params: {
                            workflowId: props.workflow.workflow_id,
                            versionId: version.workflow_version_id,
                          },
                          query: {
                            workflowModeId: version.modes?.[0] ?? undefined,
                            developerView: 'true',
                          },
                        }"
                        >View
                      </router-link>
                    </li>
                    <li>
                      <a
                        class="dropdown-item"
                        href="#"
                        data-bs-toggle="modal"
                        data-bs-target="#updateWorkflowVersionIconModal"
                        @click.prevent="
                          emit('workflow-update-icon-click', version)
                        "
                        >Update icon</a
                      >
                    </li>
                    <li>
                      <router-link
                        class="dropdown-item"
                        :to="{
                          name: 'workflow-parameter-translation',
                          params: {
                            workflowId: props.workflow.workflow_id,
                            versionId: version.workflow_version_id,
                          },
                        }"
                      >
                        Edit parameter translation
                      </router-link>
                    </li>
                    <li>
                      <router-link
                        class="dropdown-item"
                        :to="{
                          name: 'workflow-metadata',
                          params: {
                            workflowId: props.workflow.workflow_id,
                            versionId: version.workflow_version_id,
                          },
                        }"
                      >
                        Edit execution environment
                      </router-link>
                    </li>
                    <li>
                      <router-link
                        class="dropdown-item"
                        :to="{
                          name: 'workflow-parameter-visibility',
                          params: {
                            workflowId: props.workflow.workflow_id,
                            versionId: version.workflow_version_id,
                          },
                          query: {
                            modeId: version.modes?.[0] ?? undefined,
                          },
                        }"
                      >
                        Edit parameter visibility
                      </router-link>
                    </li>
                  </ul>
                </td>
              </tr>
              <tr>
                <th scope="row" class="fw-bold">Overall</th>
                <td colspan="3"></td>
                <td class="text-align-center">
                  <span
                    class="text-success me-1"
                    data-bs-toggle="tooltip"
                    data-bs-title="Successful Workflow Executions"
                  >
                    {{ successfulExecutions(workflowExecutions) }}
                    <font-awesome-icon icon="fa-solid fa-circle-check" />
                  </span>
                  <span
                    class="text-danger me-1"
                    data-bs-toggle="tooltip"
                    data-bs-title="Unsuccessful Workflow Executions"
                  >
                    {{ unsuccessfulExecutions(workflowExecutions) }}
                    <font-awesome-icon icon="fa-solid fa-x" />
                  </span>
                  <span data-bs-toggle="tooltip" data-bs-title="Unique Users">
                    {{ uniqueUsers(workflowExecutions) }}
                    <font-awesome-icon icon="fa-solid fa-user" />
                  </span>
                </td>
                <td colspan="2"></td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped>
.card-hover {
  transition: transform 0.3s ease-out;
}

@media (min-width: 992px) {
  .card-hover {
    transition: transform 0.3s ease-out;
    width: 48%;
  }
}

.card-hover:hover {
  box-shadow: var(--bs-box-shadow) !important;
}

td > img {
  max-width: 1em;
  max-height: 1em;
}

.text-align-center {
  text-align: center;
}
</style>
